
#For more control of this common code you can:
# - use a GitLab file lock to prevent changes
# - use a CODEOWNERS file to ensure specific users or groups review all changes
# - put this file in a completely different repo and reference it by an include
# - file could also be included by an https url
# If a seperate file is unnecessary these contents could be combine with .gitlab-ci.yml

# Starting with a dot is a convention to indicate this is a "template" (like a reusable function)
build-config-file:
  #Could install Java and Maven on any image rather than using the maven image
  image: maven
  stage: build

  #GitLab flow only builds when a target environment branch is merged - so no build on merge with master.
  # If you wanted to have "sandbox" be the development branch and build upon initial development, 
  # make it the default branch for the repo and delete "master"
  only:
    refs:
      - merge_requests
      - sandbox
      - stage
      - production  

  #maps branch name to environment scope
  environment:
    name: $CI_COMMIT_REF_NAME
  script:
    - |
      echo "***** FILE and ENVIRONMENT SCOPED REPO VARIABLES *****"
      source "$MAVEN_PROJ_DIR/.buildvars.sh"
      echo "This maven project is: $MAVEN_PROJ_DIR"
      echo "Building for environment branch: $CI_COMMIT_REF_NAME"
      echo "The value of a masked group varilable was passed to PWD1, whose value is: $PWD1"
      echo "The value of NONSECRETSAMEFORALLENVIRONMENTSVAR1 from $MAVEN_PROJ_DIR/.buildvars.sh is: $NONSECRETSAMEFORALLENVIRONMENTSVAR1"
      echo "The value of VISIBLE_ENV_DATA is $VISIBLE_ENV_DATA"
      echo "The value of GLOBAL_VISIBLE_VAR is $GLOBAL_VISIBLE_VAR"
      echo ""
      echo "***** GROUP INHERITED VARIABLES *****"
      echo "The value of TOP_SCOPE_VAR1 is $TOP_SCOPE_VAR1"
      echo "The value of TOP_SCOPE_VAR2 is $TOP_SCOPE_VAR2"
      echo "The value of TOP_SCOPE_VAR3 is $TOP_SCOPE_VAR3"
      echo "The value of SUBSCOPE_VAR1 is $SUBSCOPE_VAR1"
      echo "The value of SUBSCOPE_VAR2 is $SUBSCOPE_VAR2"
      echo "The value of REPO_SCOPE_VAR1 is $REPO_SCOPE_VAR1"
      echo "If you never want your built config file nor the built java artifact to be"
      echo "captured to artifacts or the runner cache, you must create the config, do the build"
      echo "and upload the artifact to your CD mechanism all in one GitLab job."

      wget https://github.com/sgoeschl/freemarker-cli/releases/download/v2.0.0-BETA-4/freemarker-cli-2.0.0-BETA-4-app.tar.gz
      tar -xf freemarker-cli-2.0.0-BETA-4-app.tar.gz

      ./freemarker-cli-2.0.0-BETA-4/bin/freemarker-cli -t template.config.properties > src/main/hello/config.properties | tee src/test/hello/config.properties

      echo "showing what is in our configuration file 'src/main/hello/config.properties' : "

      cat src/main/hello/config.properties
  
  artifacts:
    - path: src/main/hello/config.properties
